/*
 * Tiny Vector Matrix Library
 * Dense Vector Matrix Libary of Tiny size using Expression Templates
 *
 * Copyright (C) 2001, 2002 Olaf Petzold <opetzold@wit.regiocom.net>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *	
 * "$Id:"
 */

#ifndef COMPILE_TIME_ERROR
#define COMPILE_TIME_ERROR

namespace tvmet {

/**
 * \class CompileTimeError CompileTimeError.h "tvmet/CompileTimeError.h"
 * \brief Compile Time Assertation classes.
 */
template<bool> struct CompileTimeError;
template<> struct CompileTimeError<true> { };

/**
 * \def CT_CONDITION(XPR, MSG)
 * \brief Simplify the Compile Time Assertation by using an expression
 * Xpr and an error message MSG.
 */
#define CT_CONDITION(XPR, MSG) {				\
  CompileTimeError<(XPR)> ERROR_##MSG;				\
  (void)ERROR_##MSG;						\
} 

} // namespace tvmet

#endif // COMPILE_TIME_ERROR

// Local Variables:
// mode:C++
// End:
